//
//two micros:
//
//// use 'mars_rover_servo_REARmicro_HC-12'
//rear drives camera,camera motor,
//headlights,led readout bar, 3.3 Vcc
//
//front micro...drives wheel motors(6),
//via H motor driver,sonic sensor
//// use 'mars_rover_servo_driver_HC-12'
////  use HC-12 and shared HC Tx
////////////////////////////////////////////////
////////////////////////////////////////////////

#include <SoftwareSerial.h>
SoftwareSerial HC12(3,2); //2 not used
// works with 3, TX only 
// HC-12 TX Pin, HC-12 RX Pin
// yields keypad numbers 7-96
byte lastbit=25; //STOP

#include <NewPing.h>
#define MAX_DISTANCE 200
NewPing sonarft(8,12, MAX_DISTANCE);
unsigned long  oldMillis;
byte distance;

//declare variables for the motor pins
int motorPin1 = 4;  
int motorPin2 = 5; 
int motorPin3 = 6; 
int motorPin4 = 7;  

byte rite=1;
byte left=0;

byte pwm1 = 10; //pwm for motor  1,2
byte pwm2 = 11; //pwm for motor  3,4


byte rSpeed = 255; //pwm 0=low 255=hi
byte lSpeed = 255; //pwm 0=low 255=hi
int mwait = 20; //motor delay in change directions
int pon = 200; //pivot time on
byte mstatus = 0; //current motor status
//0=stop, 1=fw, 2=rv, 

///////////////////////////////////////////////////
void setup() {
  //declare the motor pins as outputs
  pinMode(motorPin1, OUTPUT);
  pinMode(motorPin2, OUTPUT);
  pinMode(motorPin3, OUTPUT);
  pinMode(motorPin4, OUTPUT);

  HC12.begin(9600); // start Serial port to HC12 

 //  Serial.begin(9600);

} //end setup

///////////////////////////////////////////////////
///////////////////////////////////////////////////
void loop(){

  if (HC12.available()) {  //read remote keys
//any read erases that data from buffer
   lastbit = HC12.read(); 
//   Serial.println(lastbit);
    delay(10);
  }

 if (millis()-oldMillis > 500 && mstatus==1) {
  distance=sonarft.ping_cm(); //0-200
 // Serial.println(distance);
  if (distance<40 && distance>0) { avoid(); }
  oldMillis=millis();
 }
 
  if (lastbit==0) { return; }
  
  if (lastbit==25) { //STOP #######################
    equalSpeed();
    digitalWrite(4,0);
    digitalWrite(5,0);
    digitalWrite(6,0);
    digitalWrite(7,0);
    mstatus=0;
  }

  if (lastbit==24) { //FORWARD  ##################
    delay(mwait);
    equalSpeed();    
    digitalWrite(4,1);
    digitalWrite(5,0);
    digitalWrite(6,1);
    digitalWrite(7,0);
    mstatus=1;
  }

  if (lastbit==82) { //REVERSE  ###################
    delay(mwait);
    equalSpeed();
    digitalWrite(4,0);
    digitalWrite(5,1);
    digitalWrite(6,0);
    digitalWrite(7,1);
    mstatus=2;
  }

  if (lastbit==90 && mstatus==0) { //PIVIT RITE ###
    equalSpeed();
    digitalWrite(4,1);
    digitalWrite(5,0);
    digitalWrite(6,0);
    digitalWrite(7,1);
    delay(pon);
    digitalWrite(4,0);
    digitalWrite(7,0);   
  }

  if (lastbit==8 && mstatus==0) { //PIVIT LEFT ###
    equalSpeed();
    digitalWrite(4,0);
    digitalWrite(5,1);
    digitalWrite(6,1);
    digitalWrite(7,0);
    delay(pon);
    digitalWrite(5,0);
    digitalWrite(6,0);     
  }  

  if (lastbit==90) { //RITE TURN  #################
    if (rSpeed<255) { 
      rSpeed+=20;
    }
   if (rSpeed==255) {
      lSpeed-=20;
      if (lSpeed<50) { lSpeed=55; }
  } 
    analogWrite(10,rSpeed);
    analogWrite(11,lSpeed);     
  }

   if (lastbit==8) { //LEFT TURN  ################
    if (lSpeed<255) { 
      lSpeed+=20;
    }
   if (lSpeed==255) {
      rSpeed-=20;
      if (rSpeed<50) { rSpeed=55; }
   } 
    analogWrite(10,rSpeed);
    analogWrite(11,lSpeed);     
  }

lastbit=0;
 
} //end main



////////  functions   /////////////////////////////
///////////////////////////////////////////////////

void equalSpeed(void) { //adj for stright drive
    rSpeed=255;
    lSpeed=255;
    analogWrite(10,rSpeed);
    analogWrite(11,lSpeed);   
}

void avoid(void) {
    equalSpeed();
    digitalWrite(4,0); //REVERSE
    digitalWrite(5,1);
    digitalWrite(6,0);
    digitalWrite(7,1); 
    delay(1200);
    digitalWrite(5,0); //STOP
    digitalWrite(7,0); 
    delay(1000);
    digitalWrite(4,1); //PIVIT RITE
    digitalWrite(5,0);
    digitalWrite(6,0);
    digitalWrite(7,1); 
    delay(pon*2);
    lastbit=24;  //FORWARD
}





